/* 
   Algorithms IE171/Spring 2005 - Lab1 - Search Algorithms
   Revision: Menal - Jan 14
*/

#include "search.hpp"

int main(int argc, char * argv[]) 
{
  
  //=========================================================================
  // Check command-line arguments
  if(argc != 2) {
    cout << "Usage: excutable inputFile." << endl;
    return 1;                         // Exit abnormally
  }
   
  //=========================================================================
  // Declare variables
  char*     target = new char[MAXLEN];  // Target word to be found
  char*     algo = new char [MAXLEN];   // Algorithm to be used
  int       i(0);                      // Loop index
   
  //=========================================================================
  // Create a Search object and read in the word list
   
  Search search(argv[1]);
   
   //=========================================================================
   // Begin continuous loop
   while (true) {

      //======================================================================
      // Prompt the user for a search term (target)
      cout << "Please enter a search term";
      cout << ", or enter \"exit\" or \"quit\" to quit: ";
      cin >> target; 
      if (strcmp(target,"quit") == 0 || strcmp(target,"exit") == 0){
	 break;
      }
      
      //======================================================================
      // Prompt the user for an algorithm
      while (true){
	 cout << "Please enter 'seq' for seqential search or ";
	 cout << "'bin' for binary search: ";
	 cin >> algo;
	 if (strcmp(algo,"seq") == 0 || strcmp(algo,"bin") == 0){
	    break;
	 }
      }

      //======================================================================
      // Search for target word.
      if (strcmp(algo,"seq") == 0){
	search.sequentialSearch(target);
      }else if (strcmp(algo,"bin") == 0){
	search.binarySearch(target);
      }
   }
   
   //=========================================================================
   // Return memory

   if(target)
     delete [] target;
   if(algo)
     delete [] algo;

   return 0; 
}
