// Course:    IE 170/171, Laboratory 1
// File name: search.cpp
// Author:    Yan Xu, Ted Ralphs
// Revision:  Menal, Jan14, Spring/05
// Purpose:   Locate a search term in an ordered list. 
// Usage:     executable inputFileName
//            For MS VS6.0 user:
//            (1) Create a project, add this file.
//            (2) Open Project menu --> Settings --> Debug, 
//                type data file name (input.txt) into Program Arguments
//                column. 
//#############################################################################

#include "search.hpp"

/*===========================================================================*/
/*====================== Constructors and Destructors =======================*/
/*===========================================================================*/

Search::Search(const char * filename):
  wordList_(0)
{
  readInput(filename);
}

/*===========================================================================*/
/*===========================================================================*/

Search::~Search()
{
  int i;

  if(wordList_){
    for(i = 0; i < wordNum_; ++i)
      delete [] wordList_[i];
    delete [] wordList_;
  }
}

/*===========================================================================*/
/*===========================================================================*/

bool Search::sequentialSearch(const char* const target) const
{
  clock_t   start(0), finish(0);            // Used to count running time
  double    runTime(0);
  bool      found (false);                  // Status of search
  int       i(0);                           // Loop index
  int       numCompare(0);                  // Total number of comparisons

   //=========================================================================
   // Start timing
   cout << "\nStarting search ..." << endl;
   start = clock();                          // Start to count search time

   //=========================================================================
   // Read through list and search for target word
 
  //************************************************************************
   //************************************************************************
   // You should fill in the loop to perform the search here. Make sure you
   // set numCompare correctly!
   //************************************************************************
   //************************************************************************

   // Stop timing
   finish = clock();                         // Finish counting search time.
   
   //=========================================================================
   // Output the search results. 
   if (found == true){               
     cout << "Target word \"" << target << "\" is in the word list.\n";
   }else{
     cout << "Target word \"" << target << "\" is not in the word list.\n";
   }
   
   //=========================================================================
   // Report running time.
   runTime = (finish - start)/(CLOCKS_PER_SEC / 1000.0); // in millisecond
   cout << "Running time is " << runTime << " milliseconds." << endl;
   cout << "Number of comparisons is " << numCompare << "." << endl << endl;
   
   return found;
}

/*===========================================================================*/
/*===========================================================================*/

bool Search:: binarySearch(const char* const target) const
{
   clock_t   start(0), finish(0);             // Used to count running time
   double    runTime(0);
   bool      found (false);                   // Status of search
   int       i(0);                            // Loop index
   int       numCompare(0);                   // Total number of comparisons

   //=========================================================================
   // Start timing
   cout << "\nStarting search ..." << endl;
   start = clock(); 
   
   //=========================================================================
   // Start recursion
   numCompare = binarySearchRecursion(0, wordNum_ - 1, target, found);

   //=========================================================================
   // Stop timing
   finish = clock(); 
   
   //=========================================================================
   // Output the search results. 
   if (found == true){               
      cout << "Target word \"" << target << "\" is in the word list.\n";
   }else{
      cout << "Target word \"" << target << "\" is not in the word list.\n";
   }
   
   //=========================================================================
   // Report running time.
   runTime = (finish - start)/(CLOCKS_PER_SEC / 1000.0); // in millisecond
   cout << "Running time is " << runTime << " milliseconds." << endl;
   cout << "Number of comparisons is " << numCompare << "." << endl << endl;
   
   return found;
}

/*===========================================================================*/
/*===========================================================================*/

bool Search::readInput(const char* const fileName)
{
   //=========================================================================
   // Declare variables and open file for reading
   clock_t   start(0), finish(0);        // Used to count running time
   double    runTime(0);
   fstream   fin(fileName, fstream::in); // Open for reading
   int i(0);                             // Loop index

   if (!fin) {                           // If input.txt can not be open 
      cout << "Unable to open input data file!" << endl;
      return false;                      
   }
   
   //=========================================================================
   // Get the number of words in the list and start timer
   cout << "Starting to read in words..." << endl;
   start = clock();                          // Start to count read in time
   fin >> wordNum_;                          // Get the num of word list
   wordList_ = new char* [wordNum_];         // Allocate memory

   //=========================================================================
   // Allocate memory
   for (i = 0; i < wordNum_; ++i)
      wordList_[i] = new char [MAXLEN];
   
   //=========================================================================
   // Read words
   for(i = 0; i < wordNum_; ++i) {
      fin >> wordList_[i];
   }

   //=========================================================================
   // Stop timing
   cout << "Finish reading in words." << endl;
   finish = clock();                    // Finish counting read in time.

   //=========================================================================
   // Report read in time
   runTime = (finish - start)/(CLOCKS_PER_SEC / 1000.0); // in millisecond
   cout << "Read in time is " << runTime << " milliseconds." << endl << endl;

   return true;
}

/*===========================================================================*/
/*===========================================================================*/

int Search::binarySearchRecursion(const int begin, const int end, 
			  const char* const target, bool& found) const
{
  int numCompare(0); 
  
  //=========================================================================
  // If the list is short enough, finish with sequential search
  if ((end - begin) < 4) {

      //**********************************************************************
      // You should fill in the loop for sequential search here. Make sure you
      // set numCompare correctly!
      //**********************************************************************

    return(numCompare);        // Return to call function (here is main(...))
  }
  
  //=========================================================================
  // Otherwise, call binary search recursively
  else { 

      //**********************************************************************
      // You should fill in the recursive call for binary search here. Make
      // sure you increment numCompare correctly!
      //**********************************************************************

  }
  return(numCompare);
}

/*===========================================================================*/
/*===========================================================================*/
