/* 
   Algorithms IE171/Spring 2005 - Lab1 - Search Algorithms
   Revision: Menal - Jan 14
*/

#ifndef SEARCH_H
#define SEARCH_H

#include <fstream>
#include <iostream>
#include <cstring>
#include <ctime>

using namespace std;

/*===========================================================================*/
/*===========================================================================*/

const int MAXLEN = 50;            // The maximum length of a word

/*===========================================================================*/
/*======================= Class declaration ==============================*/


class Search{

public:

   // Constructors and destructor
   Search();
   Search(const char * filename);
   ~Search();

  // Public methods 

  bool sequentialSearch(const char* const target) const;
			
  bool binarySearch(const char* const target) const; 

private:

  //Private data members

  int       wordNum_;           // Num of words in word list
  char**    wordList_;          // word list
  
   // Private methods 

  bool readInput(const char* const fileName); 
  int binarySearchRecursion(const int begin, const int end, 
			    const char* const target, bool& found) const;
};

#endif
